####################### 
proc remove_parentheses {value} {
####################### 

if { [regexp ^\\(.+\\)$ [string trim $value]] == 1 } {
   set value [string trim $value]
   set value [string range $value 1 [expr {[string length $value]-2}]]
   }
return $value
}

####################### 
proc add_trigger_to_slot {object field_name value} {
####################### 

set current_val [$object $field_name]
if { [regexp -nocase $value $current_val] == 0 } {
   if { [string trim $current_val] == "" } {
      $object update $field_name $value
   } else {
      $object update $field_name "$value .AND. ( $current_val )"
   }
}
}

####################### 
proc remove_trigger_from_slot {object field_name value} {
####################### 

set current_val [$object $field_name]
set res [regsub -nocase ".AND. *$value" $current_val "" new_val]
if { $res == 0 } {
    set res [regsub -nocase "$value *.AND." $current_val "" new_val]
}
if { $res == 0 } {
    set res [regsub -nocase $value $current_val "" new_val]
}
if { $res == 1 } {
   set new_val [remove_parentheses $new_val]
   $object update $field_name $new_val
}
}


####################### 
proc empty_val {xtype} {
####################### 

switch -exact $xtype {
   "MB"  { return "\" \""}
   "CB"	 { return "\" \""}
   "C"	 { return "\" \""}
   "Y"	 { return "0"}
   "D"	 { return "CTOD(\"  /  /  \")"}
   "T"	 { return "CTOT(\"  /  /  \")"}
   "B"	 { return "0"}
   "F"	 { return "0"}
   "G"	 { return "\" \""}
   "I"	 { return "0"}
   "L"	 { return ".F."}
   "M"	 { return "\" \""}
   "N"	 { return "0"}
}
}
###################### 
proc addquotes {str} {
###################### 
 if { [string first "\"" $str] == -1 } {
    return "\"$str\""
 } elseif { [string first "'"	$str] == -1 } {
   return "'$str'"
 } else {
   return "\[$str\]"
 }
}

####################### 
proc write_ri_header {} {
####################### 

>> "**__RI_HEADER!@ Do NOT REMOVE or MODIFY this line!!!! @!__RI_HEADER**"
>> "procedure TRANS_SYS_2011"
>> "nVERSION=VERSION(3)"
>> "DO CASE"
>> "   CASE nVERSION='33'	 &&	French"
>> "		RETURN \"ENREGISTREMENT VERROUILL\""
>> "   CASE nVERSION='34'	 &&	Spanish"
>> "		RETURN \"REGISTRO BLOQUEADO\""
>> "   CASE nVERSION='39'	 &&	Italian"
>> "		RETURN \"RECORD BLOCCATO\""
>> "   CASE nVERSION='42'	 &&	Czech"
>> "		RETURN \"RECORD LOCKED\""
>> "   CASE nVERSION='48'	 &&	Polish"
>> "		RETURN \"RECORD LOCKED\""
>> "   CASE nVERSION='49'	 &&	German"
>> "		RETURN \"Satz gesperrt\""
>> "   CASE nVERSION='55'	 &&	Portuguese"
>> "		RETURN \"RECORD LOCKED\""
>> "   OTHERWISE		 && English"
>> "		RETURN \"RECORD LOCKED\""
>> "ENDCASE"
>> ""
>> "procedure RIDELETE"
>> "* ridelete.prg"
>> "local llRetVal"
>> "llRetVal=.t."
>> "  IF (UPPER(SYS(2011))=TRANS_SYS_2011() and !deleted()) OR !RLOCK()"
>> "    llRetVal=.F."
>> "  ELSE"
>> "    IF !deleted()"
>> "      DELETE"
>> "      UNLOCK RECORD (RECNO())"
>> "      llRetVal=pnerror=0"
>> "    ENDIF not already deleted"
>> "  ENDIF"
>> "UNLOCK RECORD (RECNO())"
>> "return llRetVal"
>> ""
>> "procedure RIUPDATE"
>> "* riupdate"
>> "parameters tcFieldName,tcNewValue"
>> "local llRetVal"
>> "llRetVal=.t."
>> "  IF UPPER(SYS(2011))=TRANS_SYS_2011() OR !RLOCK()"
>> "    llRetVal=.F."
>> "  ELSE"
>> "    IF EVAL(tcFieldName)<>tcNewValue"
>> "      REPLACE (tcFieldName) WITH tcNewValue"
>> "*     UNLOCK RECORD (RECNO())"
>> "      llRetVal=pnerror=0"
>> "    ENDIF not already deleted"
>> "  ENDIF"
>> "UNLOCK RECORD (RECNO())"
>> "return llRetVal"
>> ""
>> "procedure rierror"
>> "parameters tnErrNo,tcMessage,tcCode,tcProgram"
>> "local lnErrorRows,lnXX"
>> "lnErrorRows=alen(gaErrors,1)"
>> "if type(\'gaErrors\[lnErrorRows,1\]\')<>\"L\""
>> "  dimension gaErrors\[lnErrorRows+1,alen(gaErrors,2)\]"
>> "  lnErrorRows=lnErrorRows+1"
>> "endif"
>> "gaErrors\[lnErrorRows,1\]=tnErrNo"
>> "gaErrors\[lnErrorRows,2\]=tcMessage"
>> "gaErrors\[lnErrorRows,3\]=tcCode"
>> "gaErrors\[lnErrorRows,4\]=\"\""
>> "lnXX=1"
>> "do while !empty(program(lnXX))"
>> "  gaErrors\[lnErrorRows,4\]=gaErrors\[lnErrorRows,4\]+\",\"+;"
>> "  program(lnXX)"
>> "  lnXX=lnXX+1"
>> "enddo"
>> "gaErrors\[lnErrorRows,5\]=pcParentDBF"
>> "gaErrors\[lnErrorRows,6\]=pnParentRec"
>> "gaErrors\[lnErrorRows,7\]=pcParentID"
>> "gaErrors\[lnErrorRows,8\]=pcParentExpr"
>> "gaErrors\[lnErrorRows,9\]=pcChildDBF"
>> "gaErrors\[lnErrorRows,10\]=pnChildRec"
>> "gaErrors\[lnErrorRows,11\]=pcChildID"
>> "gaErrors\[lnErrorRows,12\]=pcChildExpr"
>> "=messagebox(str(tnErrNo)+\" \"+tcMessage+chr(13)+tcCode+chr(13)+tcProgram)"
>> "return tnErrNo"
>> ""
>> ""
>> "PROCEDURE riopen"
>> "PARAMETERS tcTable,tcOrder"
>> "local lcCurWkArea,lcNewWkArea,lnInUseSpot"
>> "lnInUseSpot=atc(tcTable+\"*\",pcRIcursors)"
>> "IF lnInUseSpot=0"
>> "  lcCurWkArea=select()"
>> "  SELECT 0"
>> "  lcNewWkArea=select()"
>> "  IF NOT EMPTY(tcOrder)"
>> "    USE (tcTable) AGAIN ORDER (tcOrder) ;"
>> "      ALIAS (\"__ri\"+LTRIM(STR(SELECT()))) share"
>> "  ELSE"
>> "    USE (tcTable) AGAIN ALIAS (\"__ri\"+LTRIM(STR(SELECT()))) share"
>> "  ENDIF"
>> "  if pnerror=0"
>> "    pcRIcursors=pcRIcursors+upper(tcTable)+\"?\"+STR(SELECT(),5)"
>> "  else"
>> "    lcNewWkArea=0"
>> "  endif something bad happened while attempting to open the file"
>> "ELSE"
>> "  lcNewWkArea=val(substr(pcRIcursors,lnInUseSpot+len(tcTable)+1,5))"
>> "  pcRIcursors = strtran(pcRIcursors,upper(tcTable)+\"*\"+str(lcNewWkArea,5),;"
>> "    upper(tcTable)+\"?\"+str(lcNewWkArea,5))"
>> "  IF NOT EMPTY(tcOrder)"
>> "    SET ORDER TO (tcOrder) IN (lcNewWkArea)"
>> "  ENDIF sent an order"
>> "  if pnerror<>0"
>> "    lcNewWkArea=0"
>> "  endif something bad happened while setting order"
>> "ENDIF"
>> "RETURN (lcNewWkArea)"
>> ""
>> ""
>> "PROCEDURE riend"
>> "PARAMETERS tlSuccess"
>> "local lnXX,lnSpot,lcWorkArea"
>> "IF tlSuccess"
>> "  END TRANSACTION"
>> "ELSE"
>> "  SET DELETED OFF"
>> "  ROLLBACK"
>> "  SET DELETED ON"
>> "ENDIF"
>> "IF EMPTY(pcRIolderror)"
>> "  ON ERROR"
>> "ELSE"
>> "  ON ERROR &pcRIolderror."
>> "ENDIF"
>> "FOR lnXX=1 TO occurs(\"*\",pcRIcursors)"
>> "  lnSpot=atc(\"*\",pcRIcursors,lnXX)+1"
>> "  USE IN (VAL(substr(pcRIcursors,lnSpot,5)))"
>> "ENDFOR"
>> "IF pcOldDele=\"OFF\""
>> "  SET DELETED OFF"
>> "ENDIF"
>> "IF pcOldExact=\"ON\""
>> "  SET EXACT ON"
>> "ENDIF"
>> "IF pcOldTalk=\"ON\""
>> "  SET TALK ON"
>> "ENDIF"
>> "RETURN .T."
>> ""
>> ""
>> "PROCEDURE rireuse"
>> "* rireuse.prg"
>> "PARAMETERS tcTableName,tcWkArea"
>> "pcRIcursors = strtran(pcRIcursors,upper(tcTableName)+\"?\"+str(tcWkArea,5),;"
>> "  upper(tcTableName)+\"*\"+str(tcWkArea,5))"
>> "RETURN .t."

}

######################### 
proc write_transaction {} {
######################### 

>> "LOCAL llRetVal"
>> "llRetVal = .t."
>> "IF _triggerlevel=1"
>> "  BEGIN TRANSACTION"
>> "  PRIVATE pcRIcursors,pcRIwkareas,pcRIolderror,pnerror,;"
>> "  pcOldDele,pcOldExact,pcOldTalk"
>> "  pcOldTalk=SET(\"TALK\")"
>> "  SET TALK OFF"
>> "  pcOldDele=SET(\"DELETED\")"
>> "  pcOldExact=SET(\"EXACT\")"
>> "  SET DELETED ON"
>> "  SET EXACT OFF"
>> "  pcRIcursors=\"\""
>> "  pcRIwkareas=\"\""
>> "  pcRIolderror=ON(\"error\")"
>> "  pnerror=0"
>> "  ON ERROR pnerror=rierror(ERROR(),message(),message(1),program())"
>> "  IF TYPE(\'gaErrors(1)\')<>\"U\""
>> "    release gaErrors"
>> "  ENDIF"
>> "  PUBLIC gaErrors(1,12)"
>> "ENDIF first trigger"
}

######################## 
proc write_insert_triger { ent } {
######################## 

global header_done
set in_rels [$ent in_relations]
set need_triger FALSE
foreach rel $in_rels {
  if { [ $rel E_INS_RULE] == "R" } {
     if {[[ $rel PARENT] I_INDEX] != 0} {
        set need_triger TRUE
        break
	 }
  }
}
remove_trigger_from_slot $ent INS_TRIG "__ri_insert_.+\\(\\)"
if { $need_triger == "FALSE" }  {
   return
}


if {$header_done == "FALSE" } {
   write_ri_header
   set header_done TRUE
}

regsub -all " " [string tolower [$ent TITLE]] "_" low_under_e_name
add_trigger_to_slot $ent INS_TRIG "__ri_insert_${low_under_e_name}()"
>> ""
>> "********************************************************************************"
>> "** Referential integrity insert trigger for [string tolower [$ent TITLE]]"
>> "PROCEDURE __RI_INSERT_$low_under_e_name"
write_transaction
>> "PRIVATE pcParentDBF,pnParentRec,pcChildDBF,pnChildRec,pcParentID,pcChildID"
>> "PRIVATE pcParentExpr,pcChildExpr"
>> "STORE \"\" TO pcParentDBF,pcChildDBF,pcParentID,pcChildID,pcParentExpr,pcChildExpr"
>> "STORE 0 TO pnParentRec,pnChildRec"
>> "LOCAL lcChildID && child's value to be sought in parent"
>> "LOCAL lcParentWkArea && parentwork area handle returned by riopen"
>> "LOCAL lcChildWkArea && child's work area"
>> "LOCAL lcStartArea"
>> "lcStartArea=select()"
>> "llRetVal=.t."
>> "lcChildWkArea=SELECT()"
foreach rel $in_rels {
  if { [ $rel E_INS_RULE] == "R" && [[ $rel PARENT] I_INDEX] != 0 } {
	 set e_title [[$rel PARENT] TITLE]
	 set p_tag   [[[$rel PARENT] PK_INDEX] TAG]
	 >> "SELECT (lcChildWkArea)"
	 >> "lcChildID=[$rel E_K_PAREN]"
	 >> "pcChildDBF=dbf(lcChildWkArea)"
	 >> "pnChildRec=recno(lcChildWkArea)"
	 >> "pcChildID=lcChildID"
	 >> "pcChildExpr=[addquotes [[$rel FK_INDEX] INDEX_KEY]]"
  	 >> "lcParentWkArea=riopen(\"[string tolower $e_title]\",\"[string tolower $p_tag]\")"
	 >> "IF lcParentWkArea<=0"
	 >> "  IF _triggerlevel=1"
	 >> "    DO riend WITH .F."
	 >> "  ENDIF at the end of the highest trigger level"
	 >> "  SELECT (lcStartArea)"
	 >> "  RETURN .F."
	 >> "ENDIF not able to open the child work area"
	 >> "pcParentDBF=dbf(lcParentWkArea)"
	 >> "llRetVal=SEEK(lcChildID,lcParentWkArea)"
	 >> "pnParentRec=recno(lcParentWkArea)"
	 >> "=rireuse(\"[string tolower $e_title]\",lcParentWkArea)"
	 >> "IF NOT llRetVal"
	 >> "  DO rierror with -1,\"Insert restrict rule violated.\",\"\",\"\""
	 >> "  IF _triggerlevel=1"
	 >> "    DO riend WITH llRetVal"
	 >> "  ENDIF at the end of the highest trigger level"
	 >> "  SELECT (lcStartArea)"
	 >> "  RETURN llRetVal"
     >> "ENDIF"
  }
  }
>> "IF _triggerlevel=1"
>> "  do riend with llRetVal"
>> "ENDIF at the end of the highest trigger level"
>> "SELECT (lcStartArea)"
>> "RETURN llRetVal"
>> "** End of Referential integrity insert trigger for [string tolower [$ent TITLE]]"
>> "********************************************************************************"
}
######################## 
proc write_delete_triger { ent } {
######################## 
global header_done

set out_rels [$ent out_relations]
set need_triger FALSE

foreach rel $out_rels {
  if { [string first [$rel E_DEL_RULE] "\\C\\N\\R\\"] != -1 } {
     if {[$rel I_F_INDEX] != 0} {
        set need_triger TRUE
        break
     }
  }
}
remove_trigger_from_slot $ent DEL_TRIG "__ri_delete_.+\\(\\)"
if { $need_triger == "FALSE" }  {
   return
}

if { $header_done == "FALSE" }  {
   write_ri_header
   set header_done TRUE
}

regsub -all " " [string tolower [$ent TITLE]] "_" low_under_e_name
add_trigger_to_slot $ent DEL_TRIG "__ri_delete_${low_under_e_name}()"
>> ""
>> "********************************************************************************"
>> "** Referential integrity delete trigger for [string tolower [$ent TITLE]]"
>> "PROCEDURE __RI_DELETE_$low_under_e_name"

write_transaction
>> "PRIVATE pcParentDBF,pnParentRec,pcChildDBF,pnChildRec,pcParentID,pcChildID"
>> "PRIVATE pcParentExpr,pcChildExpr"
>> "STORE \"\" TO pcParentDBF,pcChildDBF,pcParentID,pcChildID,pcParentExpr,pcChildExpr"
>> "STORE 0 TO pnParentRec,pnChildRec"
>> "LOCAL lcParentID && parent's value to be sought in child"
>> "LOCAL lcChildWkArea && child work area handle returned by riopen"
>> "LOCAL lcParentWkArea"
>> "LOCAL llDelHeaderarea"
>> "lcStartArea=select()"
>> "llRetVal=.t."
>> "lcParentWkArea=select()"
foreach rel $out_rels {
  if { [$rel E_DEL_RULE] == "R" && [$rel I_F_INDEX] != 0 } {
	 set c_title [[$rel CHILD] TITLE]
	 set f_tag [[$rel FK_INDEX] TAG]
	 >> "SELECT (lcParentWkArea)"
	 >> "pcParentDBF=dbf()"
	 >> "pnParentRec=recno()"
	 >> "STORE [$rel E_K_CHILD] TO lcParentID,pcParentID"
	 >> "pcParentExpr=[addquotes [[$ent PK_INDEX] INDEX_KEY]]"
	 >> "lcChildWkArea=riopen(\"[string tolower $c_title]\",\"[string tolower $f_tag]\")"
	 >> "IF lcChildWkArea<=0"
	 >> "  IF _triggerlevel=1"
	 >> "    DO riend WITH .F."
	 >> "  ENDIF at the end of the highest trigger level"
	 >> "  RETURN .F."
	 >> "ENDIF not able to open the child work area"
	 >> "pcChildDBF=dbf(lcChildWkArea)"
	 >> "llRetVal=!SEEK(lcParentID,lcChildWkArea)"
	 >> "SELECT (lcChildWkArea)"
	 >> "pnChildRec=recno()"
	 >> "pcChildID=[[$rel FK_INDEX] INDEX_KEY]"
	 >> "pcChildExpr=[addquotes [[$rel FK_INDEX] INDEX_KEY]]"
	 >> "IF !llRetVal"
	 >> "  DO rierror with -1,\"Delete restrict rule violated.\",\"\",\"\""
	 >> "ENDIF"
	 >> "=rireuse(\"[string tolower $c_title]\",lcChildWkArea)"
	 >> "IF NOT llRetVal"
	 >> "  IF _triggerlevel=1"
	 >> "    DO riend WITH llRetVal"
	 >> "  ENDIF at the end of the highest trigger level"
	 >> "  SELECT (lcStartArea)"
	 >> "  RETURN llRetVal"
	 >> "ENDIF"
  }
  }
foreach rel $out_rels {
  if { [string first [$rel E_DEL_RULE] "\\C\\N\\"] != -1 && [$rel I_F_INDEX] != 0 } {
	 set c_title [[$rel CHILD] TITLE]
	 set f_tag [[$rel FK_INDEX] TAG]  
     >> "SELECT (lcParentWkArea)"
	 >> "pcParentDBF=dbf()"
	 >> "pnParentRec=recno()"
	 >> "STORE [$rel E_K_CHILD] TO lcParentID,pcParentID"
	 >> "pcParentExpr=[addquotes [[$ent PK_INDEX] INDEX_KEY]]"
	 >> "lcChildWkArea=riopen(\"[string tolower $c_title]\",\"[string tolower $f_tag]\")"
	 >> "IF lcChildWkArea<=0"
	 >> "  IF _triggerlevel=1"
	 >> "    DO riend WITH .F."
	 >> "  ENDIF at the end of the highest trigger level"
	 >> "  RETURN .F."
	 >> "ENDIF not able to open the child work area"
	 >> "pcChildDBF=dbf(lcChildWkArea)"
	 >> "SELECT (lcChildWkArea)"
	 >> "SEEK lcParentID"
     if { [$rel E_DEL_RULE]  == "C" } {
	    >> "SCAN WHILE [[$rel FK_INDEX] INDEX_KEY]=lcParentID AND llRetVal"
	    >> "  pnChildRec=recno()"
	    >> "  pcChildID=[[$rel FK_INDEX] INDEX_KEY]"
	    >> "  pcChildExpr=[addquotes [[$rel FK_INDEX] INDEX_KEY]]"
	    >> "  llRetVal=ridelete()"
	    >> "ENDSCAN get all of the [string tolower $c_title] records"
	 } else {
	    >> "DO WHILE [[$rel FK_INDEX] INDEX_KEY]=lcParentID AND llRetVal"
	    >> "  SKIP"
	    >> "  IF EOF() .OR. BOF()"
	    >> "     pnChildRec=0"
	    >> "  ELSE"
	    >> "     pnChildRec=recno()"
	    >> "  ENDIF"
	    >> "  SKIP -1"
	    >> "  pcChildID=[[$rel FK_INDEX] INDEX_KEY]"
	    >> "  pcChildExpr=[addquotes [[$rel FK_INDEX] INDEX_KEY]]"
	    set fkeys [$rel list_of_foreign_keys]
	    foreach fkey $fkeys {
                if { [$fkey LOGICAL]  == [falsevalue] } {
  	               >> "    llRetVal = llRetVal .AND. riupdate(\"[$fkey NAME]\",[empty_val [$fkey TYPE]])"
	            }
	    }
	    >> "  IF pnChildRec=0"
	    >> "     EXIT"
	    >> "  ELSE"
	    >> "     GOTO pnChildRec"
	    >> "  ENDIF"
	    >> "ENDDO get all of the [string tolower $c_title] records"
	 }
	 >> "=rireuse(\"[string tolower $c_title]\",lcChildWkArea)"
	 >> "IF NOT llRetVal"
	 >> "  IF _triggerlevel=1"
	 >> "    DO riend WITH llRetVal"
	 >> "  ENDIF at the end of the highest trigger level"
	 >> "  SELECT (lcStartArea)"
	 >> "  RETURN llRetVal"
	 >> "ENDIF"
  }
}
>> "IF _triggerlevel=1"
>> "  do riend with llRetVal"
>> "ENDIF at the end of the highest trigger level"
>> "SELECT (lcStartArea)"
>> "RETURN llRetVal"
>> "** End of Referential integrity Delete trigger for [string tolower [$ent TITLE]]"
>> "********************************************************************************"
}
######################## 
proc write_update_triger { ent } {
######################## 
global header_done

set in_rels [$ent in_relations]
set out_rels [$ent out_relations]
set need_upd_triger FALSE
set need_ins_triger FALSE
foreach rel $in_rels {
  if { [ $rel E_INS_RULE] == "R" } {
     if {[[ $rel PARENT] I_INDEX] != 0} {
        set need_ins_triger TRUE
        break
     }
  }
}
foreach rel $out_rels {
  if { [ $rel E_UPD_RULE] == "R" || [ $rel E_UPD_RULE] == "C"} {
     if {[$rel I_F_INDEX] != 0} {
        set need_upd_triger TRUE
        break
     }
  }
}
remove_trigger_from_slot $ent UPD_TRIG "__ri_update_.+\\(\\)"
if { $need_upd_triger == "FALSE" && $need_ins_triger == "FALSE"}  {
   return
}

if {$header_done == "FALSE" } {
   write_ri_header
   set header_done TRUE
}

regsub -all " " [string tolower [$ent TITLE]] "_" low_under_e_name
add_trigger_to_slot $ent UPD_TRIG "__ri_update_${low_under_e_name}()"
>> ""
>> "********************************************************************************"
>> "** Referential integrity update trigger for [string tolower [$ent TITLE]]"
>> "procedure __RI_UPDATE_$low_under_e_name"
write_transaction
>> "PRIVATE pcParentDBF,pnParentRec,pcChildDBF,pnChildRec,pcParentID,pcChildID"
>> "PRIVATE pcParentExpr,pcChildExpr"
>> "STORE \"\" TO pcParentDBF,pcChildDBF,pcParentID,pcChildID,pcParentExpr,pcChildExpr"
>> "STORE 0 TO pnParentRec,pnChildRec"
>> "LOCAL lcParentID && parent's value to be sought in child"
>> "LOCAL lcOldParentID && previous parent id value"
>> "LOCAL lcChildWkArea && child work area handle returned by riopen"
>> "LOCAL lcChildID && child's value to be sought in parent"
>> "LOCAL lcOldChildID && old child id value"
>> "LOCAL lcParentWkArea && parentwork area handle returned by riopen"
>> "LOCAL lcStartArea"
>> "LOCAL lcParentAlias"
>> "lcStartArea=select()"
>> "llRetVal=.t."
if { $need_ins_triger == "TRUE"}  {
>> "lcChildWkArea=select()"
   >> "IF _triggerlevel=1"
}
foreach rel $in_rels {
  if { [ $rel E_INS_RULE] == "R" && [[ $rel PARENT] I_INDEX] != 0 } {
  	 >> "  SELECT (lcChildWkArea)"
     >> "  lcChildID=[$rel E_K_PAREN]"
  	 >> "  lcOldChildID=oldval([addquotes [$rel E_K_PAREN]])"
  	 >> "  pcChildDBF=dbf(lcChildWkArea)"
  	 >> "  pnChildRec=recno(lcChildWkArea)"
  	 >> "  pcChildID=lcOldChildID"
	 >> "  pcChildExpr=[addquotes [[$rel FK_INDEX] INDEX_KEY]]"
  	 >> "  IF lcChildID<>lcOldChildID"
	 set e_title [[$rel PARENT] TITLE]
	 set p_tag   [[[$rel PARENT] PK_INDEX] TAG]
  	 >> "    lcParentWkArea=riopen(\"[string tolower $e_title]\",\"[string tolower $p_tag]\")"
  	 >> "    IF lcParentWkArea<=0"
  	 >> "      IF _triggerlevel=1"
  	 >> "        DO riend WITH .F."
  	 >> "      ENDIF at the end of the highest trigger level"
  	 >> "      SELECT (lcStartArea)"
  	 >> "      RETURN .F."
  	 >> "    ENDIF not able to open the child work area"
  	 >> "    pcParentDBF=dbf(lcParentWkArea)"
  	 >> "    llRetVal=SEEK(lcChildID,lcParentWkArea)"
  	 >> "    pnParentRec=recno(lcParentWkArea)"
  	 >> "    =rireuse(\"[string tolower $e_title]\",lcParentWkArea)"
  	 >> "    IF NOT llRetVal"
  	 >> "      DO rierror with -1,\"Insert restrict rule violated.\",\"\",\"\""
  	 >> "      IF _triggerlevel=1"
  	 >> "        DO riend WITH llRetVal"
  	 >> "      ENDIF at the end of the highest trigger level"
  	 >> "      SELECT (lcStartArea)"
  	 >> "      RETURN llRetVal"
  	 >> "    ENDIF no parent"
  	 >> "  ENDIF this value was changed"
  }
}
if { $need_ins_triger == "TRUE"}  {
   >> "ENDIF not part of a cascade"
   >> "lcParentWkArea=lcChildWkArea"
}
if { $need_ins_triger == "FALSE"}  {
   >> "lcParentWkArea=select()"
}
foreach rel $out_rels {
  if { [ $rel E_UPD_RULE] == "R" && [$rel I_F_INDEX] != 0 } {
	 set c_title [[$rel CHILD] TITLE]
	 >> "SELECT (lcParentWkArea)"
	 >> "pcParentDBF=dbf()"	  
	 >> "pnParentRec=recno()"
	 >> "lcOldParentID=OLDVAL([addquotes [$rel E_K_CHILD]])"
	 >> "pcParentID=lcOldParentID"
	 >> "pcParentExpr=[addquotes [$rel E_K_CHILD]]"
	 >> "lcParentID=[$rel E_K_CHILD]"
	 >> "IF lcParentID<>lcOldParentID"
	 >> "  lcChildWkArea=riopen(\"[string tolower $c_title]\")"
	 >> "  IF lcChildWkArea<=0"
	 >> "    IF _triggerlevel=1"
	 >> "      DO riend WITH .F."
	 >> "    ENDIF at the end of the highest trigger level"
	 >> "    SELECT (lcStartArea)"
	 >> "    RETURN .F."
	 >> "  ENDIF not able to open the child work area"
	 >> "  pcChildDBF=dbf(lcChildWkArea)"
	 >> "  SET ORDER TO [[$rel FK_INDEX] TAG] IN (lcChildWkArea)"
	 >> "  llRetVal=!SEEK(lcOldParentID,lcChildWkArea)"
	 >> "  pnChildRec=recno()"
	 >> "  * pcChildID=[[$rel FK_INDEX] INDEX_KEY]"
	 >> "  pcChildExpr=[addquotes [[$rel FK_INDEX] INDEX_KEY]]"
	 >> "  IF !llRetVal"
	 >> "    DO rierror with -1,\"Update restrict rule violated.\",\"\",\"\""
	 >> "  ENDIF"
	 >> "  =rireuse(\"[[$rel CHILD] TITLE]\",lcChildWkArea)"
	 >> "  IF NOT llRetVal"
	 >> "    IF _triggerlevel=1"
	 >> "      DO riend WITH llRetVal"
	 >> "    ENDIF at the end of the highest trigger level"
	 >> "    SELECT (lcStartArea)"
	 >> "    RETURN llRetVal"
	 >> "  ENDIF"
	 >> "ENDIF this parent id changed"
  }
}
foreach rel $out_rels {
  if { [ $rel E_UPD_RULE] == "C" && [$rel I_F_INDEX] != 0 } {
	 set c_title [[$rel CHILD] TITLE]
	 >> "SELECT (lcParentWkArea)"
	 >> "lcParentAlias=alias()"
	 >> "pcParentDBF=dbf()"
	 >> "pnParentRec=recno()"
	 >> "lcOldParentID=OLDVAL([addquotes [$rel E_K_CHILD]])"
	 >> "pcParentID=lcOldParentID"
	 >> "pcParentExpr=[addquotes [$rel E_K_CHILD]]"
	 >> "lcParentID=[$rel E_K_CHILD]"
	 >> "IF lcParentID<>lcOldParentID"
	 >> "  lcChildWkArea=riopen(\"[string tolower $c_title]\")"
	 >> "  IF lcChildWkArea<=0"
	 >> "    IF _triggerlevel=1"
	 >> "      DO riend WITH .F."
	 >> "    ENDIF at the end of the highest trigger level"
	 >> "    SELECT (lcStartArea)"
	 >> "    RETURN .F."
	 >> "  ENDIF not able to open the child work area"
	 >> "  pcChildDBF=dbf(lcChildWkArea)"
	 >> "  SELECT (lcChildWkArea)"
	 >> "  SCAN FOR [[$rel FK_INDEX] INDEX_KEY]=lcOldParentID"
	 >> "    pnChildRec=recno()"
	 >> "    pcChildID=[$rel E_K_PAREN]"
	 >> "    pcChildExpr=[addquotes [$rel E_K_PAREN]]"
	 set fkeys [$rel list_of_foreign_keys]
	 foreach fkey $fkeys {
             if { [$fkey LOGICAL]  == [falsevalue] } {
  	            >> "    llRetVal = llRetVal .AND. riupdate(\"[$fkey NAME]\",&lcParentAlias..[[$fkey PARENT $rel] NAME])"
	         }
	 }
	 >> "  ENDSCAN get all of the [string tolower $c_title] records"
	 >> "  =rireuse(\"[string tolower $c_title]\",lcChildWkArea)"
	 >> "  IF NOT llRetVal"
	 >> "    IF _triggerlevel=1"
	 >> "      DO riend WITH llRetVal"
	 >> "    ENDIF at the end of the highest trigger level"
	 >> "    SELECT (lcStartArea)"
	 >> "    RETURN llRetVal"
	 >> "  ENDIF"
	 >> "ENDIF this parent id changed"
  }
}
>> "IF _triggerlevel=1"
>> "  do riend with llRetVal"
>> "ENDIF at the end of the highest trigger level"
>> "SELECT (lcStartArea)"
>> "RETURN llRetVal"
>> "** End of Referential integrity Update trigger for [string tolower [$ent TITLE]]"
>> "********************************************************************************"
}

####################### 
proc write_ri_code {} {
####################### 
 global header_done
 set header_done FALSE
 set_marker "**__RI_HEADER!@ Do NOT REMOVE or MODIFY this line!!!! @!__RI_HEADER**"\
			"**__RI_FOOTER!@ Do NOT REMOVE or MODIFY this line!!!! @!__RI_FOOTER**"
 set entities [dict list_of_entities]
 set total [expr { [llength $entities] * 3 }] 
 set count 0.0
 foreach ent $entities {
   set count [expr $count+1.0]
   if {(([$ent dbms] != "VFP") && ([$ent dbms] != "")) || (([$ent dbms] == "") && ([[dict get_model] dbms] != "VFP"))} {
	set count [expr $count+2.0]	
	progress "[$ent TITLE] is not a VFP Table !!!" [expr $count/$total*100]
	continue
   }
   progress "Generating RI Delete CODE For Table [$ent TITLE]" [expr $count/$total*100]
   write_delete_triger $ent 
   set count [expr $count+1.0]
   progress "Generating Update RI CODE For Table [$ent TITLE]" [expr $count/$total*100]
   write_update_triger $ent 
   set count [expr $count+1.0]
   progress "Generating RI Insert CODE For Table [$ent TITLE]" [expr $count/$total*100]
   write_insert_triger $ent 
 }
if {$header_done == "TRUE" }  {
   >> "**__RI_FOOTER!@ Do NOT REMOVE or MODIFY this line!!!! @!__RI_FOOTER**"
}

}


####################
#
#  MAIN  PROGRAM
#
####################

start_progress "Generating RI CODE"
init_output
if [catch { write_ri_code } err_msg] {
   clear_output
   end_progress
   error $err_msg
}
clear_output
end_progress
